<template>
	<v-form ref="form" v-model="valid">
		<v-container grid-list-md>
			<v-layout wrap>
				<v-flex xs12>
					<v-tabs
						v-model="tab"
						background-color="primary"
						icons-and-text
						fixed-tabs
						@change="onTabChange"
					>
						<!-- First tab had some margin-left for some reason -->
						<v-tab style="margin-left: 0;">
							Link
							<v-icon>fa-link</v-icon>
						</v-tab>
						<v-tab>
							Upload
							<v-icon>fa-file-upload</v-icon>
						</v-tab>
						<v-tab>
							Known
							<v-icon>fa-images</v-icon>
						</v-tab>

						<!-- Image URL -->
						<v-tab-item>
							<v-text-field
								label="Image URL"
								prepend-icon="fa-image"
								v-model="urlImage"
								:rules="urlImageRules"
								@input="updateImage"
							/>
						</v-tab-item>

						<!-- Image upload -->
						<v-tab-item>
							<v-file-input
								label="Image"
								prepend-icon="fa-file-upload"
								accept="image/*"
								v-model="fileImage"
								:rules="fileImageRules"
								@change="updateImage"
							/>
						</v-tab-item>

						<!-- Previous Selected Images -->
						<v-tab-item>
							<image-select :images="knownImages" v-model="chosenImage" @input="updateImage" />
						</v-tab-item>
					</v-tabs>

					<small v-if="imageLoaded && $vuetify.breakpoint.smAndDown">Tap on the image to place it.</small>
					<small v-else-if="imageLoaded">Click to place the marker, click again to release it.</small>
				</v-flex>

				<v-flex v-if="value.image" xs12>
					<v-img
						alt="task image"
						contain
						min-width="100%"
						:src="value.image"
						@touchmove.prevent.stop="placeMarkerTouch"
						@click.native.stop="toggleMarker"
						@load="onImageLoad"
						@error="onImageError"
					>
						<follow-cursor align="bottom" justify="center" ref="marker" :enabled="markerFollow">
							<v-icon color="accent">fa-map-marker-alt</v-icon>
						</follow-cursor>
					</v-img>
				</v-flex>
			</v-layout>
		</v-container>
	</v-form>
</template>

<script>
import { Task } from "@/models/Task";
import FollowCursor from "@/components/FollowCursor";
import ImageSelect from "@/components/ImageSelect";
import formValidity from "@/mixins/FormValidity";
import taskService from "@/mixins/TaskService";

const defaults = {
	position: { x: -1, y: -1 },
	markerFollow: false,
	imageLoaded: false,
	tab: null,
	urlImage: null,
	fileImage: null,
	chosenImages: null,
	knownImages: []
};

export default {
	components: {
		FollowCursor,
		ImageSelect
	},

	mixins: [formValidity, taskService],

	props: {
		value: {
			type: Task,
			required: true
		}
	},

	data() {
		return {
			imageLoaded: defaults.imageLoaded,
			imageLoadedRule: v => !v || (v && this.imageLoaded) || "Image is invalid",
			markerPlacedRule: v =>
				!!v == (this.position.current.x >= 0 && this.position.current.y >= 0) ||
				"Place your marker",
			urlImageRules: [
				v => this.tab != 0 || this.imageLoadedRule(v),
				v => this.tab != 0 || this.markerPlacedRule(v)
			],
			fileImageRules: [
				v => this.tab != 1 || this.imageLoadedRule(v),
				v => this.tab != 1 || this.markerPlacedRule(v)
			],
			markerFollow: defaults.markerFollow,

			existingImage: this.value.image,

			tab: defaults.tab,
			urlImage: defaults.urlImage,
			fileImage: defaults.fileImage,
			chosenImage: defaults.chosenImage,

			knownImages: defaults.knownImages,

			position: {
				current: { ...this.value.position } || { ...defaults.position },
				default: { ...this.value.position } || { ...defaults.position }
			}
		};
	},

	mounted() {
		this.setKnownImages();
		this.setMarkerLocation();
	},

	methods: {
		setKnownImages() {
			this.taskService
				.findAll()
				.then(
					t =>
						(this.knownImages = Array.from(new Set(t.map(v => v.image))).filter(
							x => !!x
						))
				);
		},

		setMarkerLocation() {
			if (
				this.$refs.marker &&
				this.position.current.x >= 0 &&
				this.position.current.y >= 0
			) {
				this.$refs.marker.style.left = this.position.current.x * 100 + "%";
				this.$refs.marker.style.top = this.position.current.y * 100 + "%";
			}
		},

		update() {
			this.value.position = this.position.current;
			this.$emit("input", this.value);

			if (this.$refs.form) this.$refs.form.validate();
		},

		reset() {
			this.value.image = this.existingImage || defaults.image;
			this.position.current = { ...this.position.default };

			this.urlImage = this.existingImage || defaults.urlImage;
			this.fileImage = defaults.fileImage;
			this.chosenImage = defaults.chosenImage;
		},

		updateImage() {
			this.setImage();
			this.update();
		},

		setImage() {
			var file = "";

			switch (this.tab) {
				case 0:
					file = this.urlImage;
					break;
				case 1:
					if (this.fileImage instanceof File)
						file = URL.createObjectURL(this.fileImage);
					break;
				case 2:
					file = this.chosenImage;
					break;
			}

			if (!file) {
				file = this.existingImage;
			}

			this.value.image = file;
		},

		makeId(length) {
			var result = "";
			var characters =
				"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
			var charactersLength = characters.length;
			for (var i = 0; i < length; i++)
				result += characters.charAt(
					Math.floor(Math.random() * charactersLength)
				);
			return result;
		},

		toggleMarker(event) {
			if (this.markerFollow) {
				let target = event.target.getBoundingClientRect();
				this.placeMarker(
					(event.layerX - this.$refs.marker.offsetX()) / target.width,
					(event.layerY - this.$refs.marker.offsetY()) / target.height
				);
			} else {
				this.releaseMarker();
			}
		},

		placeMarker(x, y) {
			if (!this.markerFollow) {
				return;
			}

			if (!this.$vuetify.breakpoint.smAndDown) {
				this.markerFollow = false;
			}

			this.position.current.x = x;
			this.position.current.y = y;

			this.update();
		},

		placeMarkerTouch(event) {
			let target = event.target.getBoundingClientRect();
			let x =
				(event.targetTouches[0].clientX -
					target.left -
					this.$refs.marker.offsetX()) /
				target.width;
			let y =
				(event.targetTouches[0].clientY -
					target.top -
					this.$refs.marker.offsetY()) /
				target.height;
			this.placeMarker(x, y);
		},

		releaseMarker() {
			if (this.markerFollow) {
				return;
			}

			this.markerFollow = true;

			this.position.current = { ...this.position.default };

			this.update();
		},

		onTabChange() {
			this.reset();
			this.setImage();
		},

		onImageLoad() {
			this.imageLoaded = true;
			this.$refs.form.validate();
		},

		onImageError() {
			this.imageLoaded = false;
			this.$refs.form.validate();
		}
	}
};
</script>